#!/bin/zsh

# Copyright 2016 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

declare -A tpy
declare -A mpx

BR='
'

id="$_GET[id]"

tpyfile="$_DATA/therapies/$id"
mpxfile="$_DATA/prescriptions/${id%.tpy}.mpx"
client="$_DATA/vcard/${id%%.*}.vcf"

identify "$_EXEC/static/therapy_background.png" \
| sed -r 's;^.* ([0-9]+x[0-9]+) .*$;\1;' \
| read bg_dim

card_N="$(sed -nr 's:^(N)(;[^"\:]+|;"[^"]+")*\:(.*)$:\3:gp' "$client")"
card_FN="$(sed -nr 's:^(FN)(;[^"\:]+|;"[^"]+")*\:(.*)$:\3:gp' "$client")"
card_NICK="$(sed -nr 's:^(NICKNAME)(;[^"\:]+|;"[^"]+")*\:(.*)$:\3:gp' "$client")"

n=$(printf %s "$card_N" \
    | sed -rn 's:^([^;]*)(\;[^;]*)(\;[^;]*)?(\;[^;]*)?(\;[^;]*)?$:\4 \2 \3 \1 \5:gp' \
    | sed -r 's:,: :;s:\;: :g;s: +: :g;s:^ $::;'
   )
client_name="${n:-${card_FN:-${card_NICK}}}"

mpx=()
cat "$mpxfile" |while read -r line; do
  val="${line#*:}"
  mpx[${line%%:*}]="$(htmlsafe "${val//\\n/$BR}")"
done

tpy=()
cat "$tpyfile" |while read -r line; do
  val="${line#*:}"
  tpy[${line%%:*}]="$(htmlsafe "${val//\\n/$BR}")"
done
